##
##  imapd.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         imapd
Summary:      Cyrus IMAP Server
URL:          http://asg.web.cmu.edu/cyrus/imapd/
Vendor:       Carnegie Mellon University
Packager:     The OpenPKG Project
Distribution: OpenPKG [EVAL]
Group:        Mail
License:      BSD
Version:      2.1.11
Release:      20021205

#   list of sources
Source0:      ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/cyrus-imapd-%{version}.tar.gz
Source1:      imapd.conf
Source2:      rc.imapd
Patch0:       imapd.patch

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20020206, sasl, db >= 4.1.24, openssl, make, perl
PreReq:       OpenPKG, openpkg >= 20020206, sasl, openssl, MTA
AutoReq:      no
AutoReqProv:  no
Provides:     IMAP

%description

    The Cyrus IMAP server is an IMAP4 and POP3 daemon that differs from
    other IMAP server implementations in that it is generally intended to
    be run on sealed servers, where normal users are not permitted to log
    in. The mailbox database is stored in parts of the filesystem that are
    private to the Cyrus IMAP system. All user access to mail is through
    the IMAP, POP3, or KPOP protocols.

%prep
    %setup -q -n cyrus-imapd-%{version}
    %patch0 -p0

%build
    %{l_shtool} subst -e 's;db-4.1;db;g' configure
    cflags="-I%{l_prefix}/include"
    ldflags="-L%{l_prefix}/lib"
    case "%{l_target}" in
        *-solaris* ) ldflags="$ldflags -lsocket -lnsl" ;;
    esac
    CC="%{l_cc}" \
    CPPFLAGS="$cflags" \
    CFLAGS="%{l_cflags -O} $cflags" \
    LDFLAGS="$ldflags" \
    ./configure \
        --prefix=%{l_prefix} \
        --with-openssl=%{l_prefix} \
        --with-dbdir=%{l_prefix} \
        --with-sasl=%{l_prefix} \
        --with-statedir=%{l_prefix}/var/imapd \
        --with-auth=unix \
        --without-perl \
        --disable-sieve \
        --with-cyrus-prefix=%{l_prefix} \
        --with-cyrus-user=%{l_musr} \
        --with-cyrus-group=%{l_mgrp}

    #   redirect the hard coded file paths
    %{l_shtool} subst -e "s;/etc/\(.*\).conf;%{l_prefix}/etc/imapd/\\1.conf;" \
        imap/*.c imap/*.h master/*.c master/*.h
    %{l_make} %{l_mflags}

%install
    rm -rf $RPM_BUILD_ROOT
    %{l_make} %{l_mflags} install \
        prefix=$RPM_BUILD_ROOT%{l_prefix} \
        exec_prefix=$RPM_BUILD_ROOT%{l_prefix} \
        cyrus_prefix=$RPM_BUILD_ROOT%{l_prefix}
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/imapd \
        $RPM_BUILD_ROOT%{l_prefix}/var/imapd \
        $RPM_BUILD_ROOT%{l_prefix}/var/spool

    #   offer a sane configuration
    cp master/conf/small.conf master/conf/cyrus.conf
    %{l_shtool} subst -e "s;/var/imap/socket;%{l_prefix}/var/imapd/socket;g" \
        master/conf/cyrus.conf
    %{l_shtool} install -c -m 644 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_musr@;%{l_musr};g' \
        %{SOURCE imapd.conf} $RPM_BUILD_ROOT%{l_prefix}/etc/imapd/ \
        master/conf/cyrus.conf $RPM_BUILD_ROOT%{l_prefix}/etc/imapd/

    #   install the run command file
    %{l_shtool} mkdir -f -p -m 755 $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_musr@;%{l_musr};g' -e 's;@l_mgrp@;%{l_mgrp};g' \
        %{SOURCE rc.imapd} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   use mkimap to create many directories for us
    cp $RPM_BUILD_ROOT%{l_prefix}/etc/imapd/imapd.conf imapd.conf.hack
    %{l_shtool} subst -e "s;%{l_prefix};$RPM_BUILD_ROOT%{l_prefix};" \
        imapd.conf.hack
    tools/mkimap imapd.conf.hack

    #   determine files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/imapd/imapd.conf' \
        '%config %{l_prefix}/etc/imapd/cyrus.conf'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

